<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_PickUpPoint ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_PickUpPoint extends AbstractStructArrayBase
{
    /**
     * The PickUpPoint
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_PickUpPoint[]
     */
    public $PickUpPoint;
    /**
     * Constructor method for ArrayOfJPSOAP_PickUpPoint
     * @uses ArrayOfJPSOAP_PickUpPoint::setPickUpPoint()
     * @param \StructType\JPSOAP_PickUpPoint[] $pickUpPoint
     */
    public function __construct(array $pickUpPoint = array())
    {
        $this
            ->setPickUpPoint($pickUpPoint);
    }
    /**
     * Get PickUpPoint value
     * @return \StructType\JPSOAP_PickUpPoint[]|null
     */
    public function getPickUpPoint()
    {
        return $this->PickUpPoint;
    }
    /**
     * Set PickUpPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_PickUpPoint[] $pickUpPoint
     * @return \ArrayType\ArrayOfJPSOAP_PickUpPoint
     */
    public function setPickUpPoint(array $pickUpPoint = array())
    {
        foreach ($pickUpPoint as $arrayOfJPSOAP_PickUpPointPickUpPointItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_PickUpPointPickUpPointItem instanceof \StructType\JPSOAP_PickUpPoint) {
                throw new \InvalidArgumentException(sprintf('The PickUpPoint property can only contain items of \StructType\JPSOAP_PickUpPoint, "%s" given', is_object($arrayOfJPSOAP_PickUpPointPickUpPointItem) ? get_class($arrayOfJPSOAP_PickUpPointPickUpPointItem) : gettype($arrayOfJPSOAP_PickUpPointPickUpPointItem)), __LINE__);
            }
        }
        $this->PickUpPoint = $pickUpPoint;
        return $this;
    }
    /**
     * Add item to PickUpPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_PickUpPoint $item
     * @return \ArrayType\ArrayOfJPSOAP_PickUpPoint
     */
    public function addToPickUpPoint(\StructType\JPSOAP_PickUpPoint $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_PickUpPoint) {
            throw new \InvalidArgumentException(sprintf('The PickUpPoint property can only contain items of \StructType\JPSOAP_PickUpPoint, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PickUpPoint[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PickUpPoint
     */
    public function getAttributeName()
    {
        return 'PickUpPoint';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_PickUpPoint
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
